Commit | Line | Data |
---|---|---|
2ea4288a | 1 | #!/bin/bash |
2385300a | 2 | # Desc: Template to report seconds until beginning of next day |
5ef33b04 | 3 | # Author: Steven Baltaktei Sandoval; License: GPLv3+ |
2ea4288a SBS |
4 | |
5 | #==BEGIN Define script parameters== | |
6 | #===BEGIN Declare local script functions=== | |
5ef33b04 SBS |
7 | yell() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; # Ref/Attrib: https://stackoverflow.com/a/25515370 |
8 | die() { yell "$*"; exit 111; } | |
9 | try() { "$@" || die "cannot $*"; } | |
2385300a SBS |
10 | timeUntilNextDay(){ |
11 | # Desc: Report seconds until next day. | |
12 | # Output: stdout: integer seconds until next day | |
5ef33b04 | 13 | # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0 |
2385300a SBS |
14 | # Usage: timeUntilNextDay |
15 | # Usage: if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement"; exit 1; fi | |
b03c9c0c SBS |
16 | local returnState TIME_CURRENT TIME_NEXT_DAY SECONDS_UNTIL_NEXT_DAY |
17 | TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second. | |
18 | TIME_NEXT_DAY="$(date -d "$TIME_CURRENT next day" --iso-8601=date)"; # Produce timestamp of beginning of tomorrow with resolution of 1 second. | |
19 | SECONDS_UNTIL_NEXT_DAY="$(( $(date +%s -d "$TIME_NEXT_DAY") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second). | |
2385300a | 20 | if [[ "$SECONDS_UNTIL_NEXT_DAY" -gt 0 ]]; then |
5ef33b04 | 21 | returnState="true"; |
2385300a | 22 | elif [[ "$SECONDS_UNTIL_NEXT_DAY" -eq 0 ]]; then |
5ef33b04 | 23 | returnState="WARNING_ZERO"; |
2385300a SBS |
24 | yell "WARNING:Reported time until next day exactly zero."; |
25 | elif [[ "$SECONDS_UNTIL_NEXT_DAY" -lt 0 ]]; then | |
5ef33b04 | 26 | returnState="WARNING_NEGATIVE"; |
2385300a | 27 | yell "WARNING:Reported time until next day is negative."; |
5ef33b04 SBS |
28 | fi |
29 | ||
2385300a | 30 | try echo "$SECONDS_UNTIL_NEXT_DAY"; # Report |
5ef33b04 SBS |
31 | |
32 | #===Determine function return code=== | |
33 | if [[ "$returnState" = "true" ]]; then | |
34 | return 0; | |
35 | elif [[ "$returnState" = "WARNING_ZERO" ]]; then | |
36 | return 1; | |
37 | elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then | |
38 | return 2; | |
39 | fi | |
df807a6c | 40 | } # Report seconds until next day |
2ea4288a SBS |
41 | #===END Declare local script functions=== |
42 | #==END Define script parameters== | |
43 | ||
44 | ||
45 | #==BEGIN sample code== | |
2385300a | 46 | try echo "Time until next day (seconds):$(timeUntilNextDay)" # simple report |
5ef33b04 | 47 | |
2385300a | 48 | if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement for myTTL:$myTTL"; exit 1; fi # Use of exit code to exit early if time <= 0. |
2ea4288a | 49 | #==END sample code== |